/*
 * Generated by Bluespec Compiler, version 2015.09.beta2 (build 34689, 2015-09-07)
 * 
 * On Tue Jul 19 13:21:16 IST 2016
 * 
 */
#include "bluesim_primitives.h"
#include "module_fn_arithmetic.h"


/* Constructor */
MOD_module_fn_arithmetic::MOD_module_fn_arithmetic(tSimStateHdl simHdl,
						   char const *name,
						   Module *parent)
  : Module(simHdl, name, parent),
    INST_instance_fn_sra_srl_4(simHdl, "instance_fn_sra_srl_4", this),
    INST_instance_fn_sltu_3(simHdl, "instance_fn_sltu_3", this),
    INST_instance_fn_slt_2(simHdl, "instance_fn_slt_2", this),
    INST_instance_fn_sll_1(simHdl, "instance_fn_sll_1", this),
    INST_instance_fn_addsub_0(simHdl, "instance_fn_addsub_0", this),
    DEF_fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75(68u)
{
  PORT_fn_arithmetic.setSize(133u);
  PORT_fn_arithmetic.clear();
  symbol_count = 6u;
  symbols = new tSym[symbol_count];
  init_symbols_0();
}


/* Symbol init fns */

void MOD_module_fn_arithmetic::init_symbols_0()
{
  init_symbol(&symbols[0u], "fn_arithmetic", SYM_PORT, &PORT_fn_arithmetic, 133u);
  init_symbol(&symbols[1u], "instance_fn_addsub_0", SYM_MODULE, &INST_instance_fn_addsub_0);
  init_symbol(&symbols[2u], "instance_fn_sll_1", SYM_MODULE, &INST_instance_fn_sll_1);
  init_symbol(&symbols[3u], "instance_fn_slt_2", SYM_MODULE, &INST_instance_fn_slt_2);
  init_symbol(&symbols[4u], "instance_fn_sltu_3", SYM_MODULE, &INST_instance_fn_sltu_3);
  init_symbol(&symbols[5u], "instance_fn_sra_srl_4", SYM_MODULE, &INST_instance_fn_sra_srl_4);
}


/* Rule actions */


/* Methods */

tUWide MOD_module_fn_arithmetic::METH_fn_arithmetic(tUInt8 ARG_fn_arithmetic__opcode,
						    tUInt8 ARG_fn_arithmetic__funct3,
						    tUInt8 ARG_fn_arithmetic__funct7,
						    tUInt64 ARG_fn_arithmetic__operand1,
						    tUInt64 ARG_fn_arithmetic__operand2,
						    tUInt32 ARG_fn_arithmetic__immediate_value,
						    tUInt64 ARG_fn_arithmetic_program_counter)
{
  tUInt8 DEF_x__h308;
  tUInt64 DEF_SEXT_fn_arithmetic__immediate_value_BITS_11_TO_ETC___d47;
  tUInt8 DEF_NOT_fn_arithmetic__opcode_EQ_0b0_3_9_AND_NOT_f_ETC___d71;
  tUInt8 DEF_fn_arithmetic__opcode_EQ_0b1100_0_AND_fn_arith_ETC___d21;
  tUInt8 DEF_fn_arithmetic__funct3_EQ_0b0___d11;
  tUInt8 DEF_fn_arithmetic__opcode_EQ_0b0___d13;
  tUInt8 DEF_fn_arithmetic__opcode_EQ_0b1000___d15;
  tUInt8 DEF_fn_arithmetic__opcode_EQ_0b1110___d8;
  tUInt64 DEF_SEXT_fn_addsub_3_BITS_31_TO_0_4___d35;
  tUInt64 DEF_alu_result___1__h541;
  tUInt64 DEF_alu_result___1__h540;
  tUInt64 DEF_alu_result___1__h103;
  tUInt64 DEF_alu_result___1__h95;
  tUInt64 DEF_alu_result___1__h681;
  tUInt64 DEF_alu_result___1__h680;
  tUInt64 DEF_alu_result___1__h729;
  tUInt64 DEF_alu_result___1__h728;
  tUInt64 DEF_IF_fn_arithmetic__funct3_EQ_0b1_7_THEN_fn_sll__ETC___d66;
  tUInt64 DEF_alu_result___1__h175;
  tUInt64 DEF_x__h25;
  tUInt8 DEF_y__h310;
  tUInt8 DEF_fn_arithmetic__opcode_BIT_3___d2;
  tUInt32 DEF_x__h194;
  tUInt64 DEF_fn_addsub___d33;
  tUInt64 DEF_alu_result___1__h353;
  tUInt64 DEF_alu_result___1__h425;
  tUInt64 DEF_alu_result___1__h472;
  tUInt8 DEF_fn_arithmetic__opcode_BIT_1___d39;
  tUInt8 DEF_INV_fn_arithmetic__opcode_BIT_3___d38;
  tUInt8 DEF_fn_arithmetic__funct7_BIT_5___d25;
  tUInt32 DEF_x__h732;
  tUInt64 DEF_alu_result___1__h567;
  DEF_x__h732 = (tUInt32)(4095u & ARG_fn_arithmetic__immediate_value);
  DEF_fn_arithmetic__funct7_BIT_5___d25 = (tUInt8)((tUInt8)1u & (ARG_fn_arithmetic__funct7 >> 5u));
  DEF_fn_arithmetic__opcode_BIT_1___d39 = (tUInt8)((tUInt8)1u & (ARG_fn_arithmetic__opcode >> 1u));
  DEF_fn_arithmetic__opcode_BIT_3___d2 = (tUInt8)((tUInt8)1u & (ARG_fn_arithmetic__opcode >> 3u));
  DEF_INV_fn_arithmetic__opcode_BIT_3___d38 = (tUInt8)1u & ~DEF_fn_arithmetic__opcode_BIT_3___d2;
  DEF_alu_result___1__h567 = INST_instance_fn_sra_srl_4.METH_fn_sra_srl(ARG_fn_arithmetic__operand1,
									ARG_fn_arithmetic__operand2,
									DEF_x__h732,
									DEF_fn_arithmetic__funct7_BIT_5___d25,
									DEF_INV_fn_arithmetic__opcode_BIT_3___d38,
									DEF_fn_arithmetic__opcode_BIT_1___d39);
  DEF_alu_result___1__h472 = INST_instance_fn_sltu_3.METH_fn_sltu(ARG_fn_arithmetic__operand1,
								  ARG_fn_arithmetic__operand2,
								  DEF_x__h732,
								  DEF_INV_fn_arithmetic__opcode_BIT_3___d38);
  DEF_alu_result___1__h425 = INST_instance_fn_slt_2.METH_fn_slt(ARG_fn_arithmetic__operand1,
								ARG_fn_arithmetic__operand2,
								DEF_x__h732,
								DEF_INV_fn_arithmetic__opcode_BIT_3___d38);
  DEF_alu_result___1__h353 = INST_instance_fn_sll_1.METH_fn_sll(ARG_fn_arithmetic__operand1,
								ARG_fn_arithmetic__operand2,
								DEF_x__h732,
								DEF_INV_fn_arithmetic__opcode_BIT_3___d38,
								DEF_fn_arithmetic__opcode_BIT_1___d39);
  DEF_y__h310 = (tUInt8)((tUInt8)1u & (ARG_fn_arithmetic__opcode >> 2u));
  DEF_alu_result___1__h728 = ARG_fn_arithmetic__operand1 & ARG_fn_arithmetic__operand2;
  DEF_alu_result___1__h680 = ARG_fn_arithmetic__operand1 | ARG_fn_arithmetic__operand2;
  DEF_alu_result___1__h95 = (((tUInt64)(4503599627370495llu & primSignExt64(64u,
									    20u,
									    (tUInt32)(ARG_fn_arithmetic__immediate_value)))) << 12u) | (tUInt64)(0u);
  DEF_alu_result___1__h103 = DEF_alu_result___1__h95 + ARG_fn_arithmetic_program_counter;
  DEF_alu_result___1__h540 = ARG_fn_arithmetic__operand1 ^ ARG_fn_arithmetic__operand2;
  DEF_fn_arithmetic__opcode_EQ_0b1110___d8 = ARG_fn_arithmetic__opcode == (tUInt8)14u;
  DEF_fn_arithmetic__opcode_EQ_0b1000___d15 = ARG_fn_arithmetic__opcode == (tUInt8)8u;
  DEF_fn_arithmetic__opcode_EQ_0b0___d13 = ARG_fn_arithmetic__opcode == (tUInt8)0u;
  DEF_fn_arithmetic__funct3_EQ_0b0___d11 = ARG_fn_arithmetic__funct3 == (tUInt8)0u;
  DEF_fn_arithmetic__opcode_EQ_0b1100_0_AND_fn_arith_ETC___d21 = ARG_fn_arithmetic__opcode == (tUInt8)12u && DEF_fn_arithmetic__funct3_EQ_0b0___d11;
  DEF_NOT_fn_arithmetic__opcode_EQ_0b0_3_9_AND_NOT_f_ETC___d71 = !DEF_fn_arithmetic__opcode_EQ_0b0___d13 && !DEF_fn_arithmetic__opcode_EQ_0b1000___d15;
  DEF_x__h308 = DEF_fn_arithmetic__opcode_BIT_3___d2 & DEF_y__h310;
  DEF_fn_addsub___d33 = INST_instance_fn_addsub_0.METH_fn_addsub(ARG_fn_arithmetic__operand1,
								 ARG_fn_arithmetic__operand2,
								 DEF_x__h732,
								 (DEF_fn_arithmetic__opcode_EQ_0b1100_0_AND_fn_arith_ETC___d21 && DEF_fn_arithmetic__funct7_BIT_5___d25) || ((DEF_fn_arithmetic__opcode_EQ_0b1110___d8 && DEF_fn_arithmetic__funct3_EQ_0b0___d11) && DEF_fn_arithmetic__funct7_BIT_5___d25),
								 (tUInt8)1u & ~DEF_x__h308);
  DEF_x__h194 = (tUInt32)(DEF_fn_addsub___d33);
  DEF_SEXT_fn_addsub_3_BITS_31_TO_0_4___d35 = primSignExt64(64u, 32u, (tUInt32)(DEF_x__h194));
  switch (ARG_fn_arithmetic__opcode) {
  case (tUInt8)6u:
  case (tUInt8)14u:
    DEF_alu_result___1__h175 = DEF_SEXT_fn_addsub_3_BITS_31_TO_0_4___d35;
    break;
  default:
    DEF_alu_result___1__h175 = DEF_fn_addsub___d33;
  }
  DEF_SEXT_fn_arithmetic__immediate_value_BITS_11_TO_ETC___d47 = primSignExt64(64u,
									       12u,
									       (tUInt32)(DEF_x__h732));
  DEF_alu_result___1__h729 = ARG_fn_arithmetic__operand1 & DEF_SEXT_fn_arithmetic__immediate_value_BITS_11_TO_ETC___d47;
  DEF_alu_result___1__h681 = ARG_fn_arithmetic__operand1 | DEF_SEXT_fn_arithmetic__immediate_value_BITS_11_TO_ETC___d47;
  DEF_alu_result___1__h541 = ARG_fn_arithmetic__operand1 ^ DEF_SEXT_fn_arithmetic__immediate_value_BITS_11_TO_ETC___d47;
  switch (ARG_fn_arithmetic__funct3) {
  case (tUInt8)1u:
    DEF_IF_fn_arithmetic__funct3_EQ_0b1_7_THEN_fn_sll__ETC___d66 = DEF_alu_result___1__h353;
    break;
  case (tUInt8)2u:
    DEF_IF_fn_arithmetic__funct3_EQ_0b1_7_THEN_fn_sll__ETC___d66 = DEF_alu_result___1__h425;
    break;
  case (tUInt8)3u:
    DEF_IF_fn_arithmetic__funct3_EQ_0b1_7_THEN_fn_sll__ETC___d66 = DEF_alu_result___1__h472;
    break;
  case (tUInt8)4u:
    DEF_IF_fn_arithmetic__funct3_EQ_0b1_7_THEN_fn_sll__ETC___d66 = DEF_fn_arithmetic__opcode_BIT_3___d2 ? DEF_alu_result___1__h540 : DEF_alu_result___1__h541;
    break;
  case (tUInt8)5u:
    DEF_IF_fn_arithmetic__funct3_EQ_0b1_7_THEN_fn_sll__ETC___d66 = DEF_alu_result___1__h567;
    break;
  case (tUInt8)6u:
    DEF_IF_fn_arithmetic__funct3_EQ_0b1_7_THEN_fn_sll__ETC___d66 = DEF_fn_arithmetic__opcode_BIT_3___d2 ? DEF_alu_result___1__h680 : DEF_alu_result___1__h681;
    break;
  case (tUInt8)7u:
    DEF_IF_fn_arithmetic__funct3_EQ_0b1_7_THEN_fn_sll__ETC___d66 = DEF_fn_arithmetic__opcode_BIT_3___d2 ? DEF_alu_result___1__h728 : DEF_alu_result___1__h729;
    break;
  default:
    DEF_IF_fn_arithmetic__funct3_EQ_0b1_7_THEN_fn_sll__ETC___d66 = 0llu;
  }
  DEF_x__h25 = (tUInt8)((tUInt8)1u & ARG_fn_arithmetic__opcode) ? (DEF_fn_arithmetic__opcode_BIT_3___d2 ? DEF_alu_result___1__h95 : DEF_alu_result___1__h103) : ((((((DEF_fn_arithmetic__opcode_EQ_0b1110___d8 || ARG_fn_arithmetic__opcode == (tUInt8)6u) && DEF_fn_arithmetic__funct3_EQ_0b0___d11) || DEF_fn_arithmetic__opcode_EQ_0b0___d13) || DEF_fn_arithmetic__opcode_EQ_0b1000___d15) || (ARG_fn_arithmetic__opcode == (tUInt8)4u && DEF_fn_arithmetic__funct3_EQ_0b0___d11)) || DEF_fn_arithmetic__opcode_EQ_0b1100_0_AND_fn_arith_ETC___d21 ? DEF_alu_result___1__h175 : DEF_IF_fn_arithmetic__funct3_EQ_0b1_7_THEN_fn_sll__ETC___d66);
  DEF_fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75.set_bits_in_word((tUInt8)(ARG_fn_arithmetic__operand2 >> 60u),
										2u,
										0u,
										4u).set_whole_word((tUInt32)(ARG_fn_arithmetic__operand2 >> 28u),
												   1u).set_whole_word((((((tUInt32)(268435455u & ARG_fn_arithmetic__operand2)) << 4u) | (((tUInt32)((tUInt8)((tUInt8)3u & ARG_fn_arithmetic__funct3))) << 2u)) | (((tUInt32)((tUInt8)(ARG_fn_arithmetic__funct3 >> 2u))) << 1u)) | (tUInt32)(DEF_fn_arithmetic__opcode_EQ_0b1000___d15),
														      0u);
  PORT_fn_arithmetic.set_bits_in_word((tUInt8)(DEF_x__h25 >> 59u),
				      4u,
				      0u,
				      5u).set_whole_word((tUInt32)(DEF_x__h25 >> 27u),
							 3u).set_whole_word(((((tUInt32)(134217727u & DEF_x__h25)) << 5u) | (((tUInt32)(DEF_NOT_fn_arithmetic__opcode_EQ_0b0_3_9_AND_NOT_f_ETC___d71)) << 4u)) | (tUInt32)(DEF_fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75.get_bits_in_word8(2u,
																																					  0u,
																																					  4u)),
									    2u).set_whole_word(DEF_fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75.get_whole_word(1u),
											       1u).set_whole_word(DEF_fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75.get_whole_word(0u),
														  0u);
  return PORT_fn_arithmetic;
}

tUInt8 MOD_module_fn_arithmetic::METH_RDY_fn_arithmetic()
{
  tUInt8 PORT_RDY_fn_arithmetic;
  tUInt8 DEF_CAN_FIRE_fn_arithmetic;
  DEF_CAN_FIRE_fn_arithmetic = (tUInt8)1u;
  PORT_RDY_fn_arithmetic = DEF_CAN_FIRE_fn_arithmetic;
  return PORT_RDY_fn_arithmetic;
}


/* Reset routines */


/* Static handles to reset routines */


/* Functions for the parent module to register its reset fns */


/* Functions to set the elaborated clock id */


/* State dumping routine */
void MOD_module_fn_arithmetic::dump_state(unsigned int indent)
{
}


/* VCD dumping routines */

unsigned int MOD_module_fn_arithmetic::dump_VCD_defs(unsigned int levels)
{
  vcd_write_scope_start(sim_hdl, inst_name);
  vcd_num = vcd_reserve_ids(sim_hdl, 2u);
  unsigned int num = vcd_num;
  for (unsigned int clk = 0u; clk < bk_num_clocks(sim_hdl); ++clk)
    vcd_add_clock_def(sim_hdl, this, bk_clock_name(sim_hdl, clk), bk_clock_vcd_num(sim_hdl, clk));
  vcd_write_def(sim_hdl, num++, "fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75", 68u);
  vcd_write_def(sim_hdl, num++, "fn_arithmetic", 133u);
  if (levels != 1u)
  {
    unsigned int l = levels == 0u ? 0u : levels - 1u;
    num = INST_instance_fn_addsub_0.dump_VCD_defs(l);
    num = INST_instance_fn_sll_1.dump_VCD_defs(l);
    num = INST_instance_fn_slt_2.dump_VCD_defs(l);
    num = INST_instance_fn_sltu_3.dump_VCD_defs(l);
    num = INST_instance_fn_sra_srl_4.dump_VCD_defs(l);
  }
  vcd_write_scope_end(sim_hdl);
  return num;
}

void MOD_module_fn_arithmetic::dump_VCD(tVCDDumpType dt,
					unsigned int levels,
					MOD_module_fn_arithmetic &backing)
{
  vcd_defs(dt, backing);
  if (levels != 1u)
    vcd_submodules(dt, levels - 1u, backing);
}

void MOD_module_fn_arithmetic::vcd_defs(tVCDDumpType dt, MOD_module_fn_arithmetic &backing)
{
  unsigned int num = vcd_num;
  if (dt == VCD_DUMP_XS)
  {
    vcd_write_x(sim_hdl, num++, 68u);
    vcd_write_x(sim_hdl, num++, 133u);
  }
  else
    if (dt == VCD_DUMP_CHANGES)
    {
      if ((backing.DEF_fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75) != DEF_fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75)
      {
	vcd_write_val(sim_hdl, num, DEF_fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75, 68u);
	backing.DEF_fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75 = DEF_fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75;
      }
      ++num;
      if ((backing.PORT_fn_arithmetic) != PORT_fn_arithmetic)
      {
	vcd_write_val(sim_hdl, num, PORT_fn_arithmetic, 133u);
	backing.PORT_fn_arithmetic = PORT_fn_arithmetic;
      }
      ++num;
    }
    else
    {
      vcd_write_val(sim_hdl, num++, DEF_fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75, 68u);
      backing.DEF_fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75 = DEF_fn_arithmetic__operand2_CONCAT_fn_arithmetic___ETC___d75;
      vcd_write_val(sim_hdl, num++, PORT_fn_arithmetic, 133u);
      backing.PORT_fn_arithmetic = PORT_fn_arithmetic;
    }
}

void MOD_module_fn_arithmetic::vcd_submodules(tVCDDumpType dt,
					      unsigned int levels,
					      MOD_module_fn_arithmetic &backing)
{
  INST_instance_fn_addsub_0.dump_VCD(dt, levels, backing.INST_instance_fn_addsub_0);
  INST_instance_fn_sll_1.dump_VCD(dt, levels, backing.INST_instance_fn_sll_1);
  INST_instance_fn_slt_2.dump_VCD(dt, levels, backing.INST_instance_fn_slt_2);
  INST_instance_fn_sltu_3.dump_VCD(dt, levels, backing.INST_instance_fn_sltu_3);
  INST_instance_fn_sra_srl_4.dump_VCD(dt, levels, backing.INST_instance_fn_sra_srl_4);
}
